Index: branches/encoders/code/lib/src/libdragonfly/encoders.c
===================================================================
--- branches/encoders/code/lib/src/libdragonfly/encoders.c	(revision 1344)
+++ branches/encoders/code/lib/src/libdragonfly/encoders.c	(revision 1345)
@@ -19,10 +19,6 @@
 int right_dx;
 long int timecount;
 
-int left_v;
-int right_v;
-
-
 volatile short int data_ready;
 
 void encoder_recv(char data);
@@ -38,38 +34,23 @@
 inline unsigned int right_data_array_prev(void);
 inline unsigned int right_data_array_bottom(void);
 
-//RING_BUFFER_NEW(enc_buffer, BUFFER_SIZE, short int);
 
-void encoder_recv_complete(void);
-
 void encoder_recv_complete(){
-   encoder_buf_index = 0;
-   //  usb_puts("[");usb_puti(left_dx);usb_puts(",");usb_puti(right_dx);usb_puts("]\r\n");
-   //   usb_puts("\r\n");
-  data_ready++;
+  	encoder_buf_index = 0;
+	data_ready++;
   
-  //delay_ms(ENCODER_DELAY);
-
-   spi_transfer(5);
+   	spi_transfer(5);
 }
 
-void put_bin(char data){
-  int i;
-
-  for(i=7;i>=0;i--)
-    usb_puti((data>>i)&1);
-  usb_puts(" ");
-}
-
-/**
- * Initializes the encoders variables
- **/
+/** 
+* @brief Initializes encoder variables and the hardware interface.
+*/
 void encoders_init(void){
 	int i;
 	
 	data_ready=0;
 
-	spi_init(encoder_recv/*put_bin*/, encoder_recv_complete);
+	spi_init(encoder_recv, encoder_recv_complete);
 	encoder_buf_index = 0;
 	left_data_buf = 0;
 	right_data_buf= 0;
@@ -76,10 +57,6 @@
 	left_data = -1;
 	right_data = -1;
 	
-	
-	left_v=0;
-	right_v=0;
-	
 	//RING_BUFFER_INIT(enc_buffer,BUFFER_SIZE);
 	left_data_idx = 0;
 	right_data_idx = 0;
@@ -90,11 +67,10 @@
 		right_data_array[i] = 0;
 	}
 	spi_transfer(5);
-	usb_puts("\tencoders.c Debug: ENCODERS INITIALIZED\n\r");
 }
 
 /**
- * Returns the specified encoders value
+ * @brief Returns the specified encoders value
  *
  * @param encoder this is the encoder that you want to read. Valid arguments
  *          are LEFT and RIGHT
@@ -102,100 +78,138 @@
  * @return the value of the specified encoder
  **/
 int encoder_read(char encoder){
-	if(encoder==LEFT){
-		usb_puts("\tencoders.c Debug: PRINTING LEFT ENCODER VALUE\n\r");
-		return left_data;
-	}
-	else if(encoder==RIGHT){
-		usb_puts("\tencoders.c Debug: PRINTING RIGHT ENCODER VALUE\n\r");
-		return right_data;
-	}
-	else{
-		usb_puts("\tencoders.c Debug: INVALID ENCODER - USE LEFT/RIGHT\n\r");
-		 return -1;
-	}
+	
+	if(encoder==LEFT) return left_data;
+	else if(encoder==RIGHT) return right_data;
+	else return -1;
 }
 
-int encoder_change(char encoder){
-	return 0;
-}
 
+/** 
+* @brief Outputs encoder direction as FORWARD OR BACK
+* A STUB! DO NOT use.
+* 
+* @param encoder The encoder you want the direction of.
+* Valid arguments are right and left.
+* 
+* @return FORWARD or BACK (the constants)
+*/
 char encoder_direction(char encoder){
 	return 0;
 }
+
 /**
- * Gets the velocity of the specified encoder.
+ * Gets the total distance covered by the specified encoder (in encoder clicks)
  *
  * @param encoder the encoder that you want to read, use LEFT or RIGHT
  *
- * @return The velocity of the specified encoder.
+ * @return The distance covered by the specified encoder.
  **/
 int encoder_get_dx(char encoder) {
-	if(encoder==LEFT)
-		return left_dx;
-	else if(encoder==RIGHT)
-		return right_dx;
+	
+	if(encoder==LEFT) return left_dx;
+	else if(encoder==RIGHT) return right_dx;
 	else return -1;
 }
 
 /**
- * Resets the value of the velocity global variable for the specified
+ * Resets the distance accumulator for the specified
  *  encoder.
  *
- * @param encoder the encoder that you want to modify
+ * @param encoder the encoder that you want to reset distance for
  **/
 void encoder_rst_dx(char encoder) {
-	if(encoder==LEFT)
-		left_dx = 0;
-	else if(encoder==RIGHT)
-		right_dx = 0;
+	
+	if(encoder==LEFT) left_dx = 0;
+	else if(encoder==RIGHT) right_dx = 0;
 }
 
-/**
- * Returns the current time count for the encoders.
- **/
+/** 
+* @brief Returns the number of encoder reads that have occurred.
+* 
+* @return The time count.
+*/
 int encoder_get_tc(void) {
 	return timecount;
 }
 
-/**
- * Resets the time count for the encoders.
- **/
+/** 
+* @brief Resets the encoder read counter.
+*/
 void encoder_rst_tc(void) {
 	timecount = 0;
 }
 
+///////////////////////////////////////////////////////////////////////
+int left_data_at(int index) {
+	int tmp_idx = left_data_idx - index;
+	if (tmp_idx < 0)
+		tmp_idx += BUFFER_SIZE;
+	return left_data_array[tmp_idx];
+}
 
+int right_data_at(int index) {
+	int tmp_idx = right_data_idx - index;
+	if (tmp_idx < 0)
+		tmp_idx += BUFFER_SIZE;
+	return right_data_array[tmp_idx];	
+}
+
+
+int get_dx(char encoder, int index) {
+	int dx, ctr;
+	ctr = 0;
+	dx = 1024;
+	do {
+		if (encoder == LEFT)
+			dx = left_data_at(index+ctr+38) - left_data_at(index+ctr);
+		else
+			dx = right_data_at(index+ctr) - right_data_at(index+ctr+38);
+		ctr++;
+	} while ((dx > 30 || dx < -30) && ctr < 3);
+	if (dx > 30 || dx < -30)
+		return ERR_VEL;
+	return dx;
+}
+/** 
+* @brief Returns the approximated instantaneous velocity of the robot
+* in terms of encoder clicks.
+* 
+* @param encoder RIGHT or LEFT - the wheel you want the velocity for.
+* 
+* @return The instantaneous velocity for the given wheel.
+*/
 int encoder_get_v(char encoder){
-	int last, res=0;
-	
-	cli();
-	
-	if(encoder==LEFT){
-		if(left_data_idx==0)
-			last = BUFFER_SIZE - 1;
-		else
-			last = left_data_idx - 1;
-		res = ((int)left_data_array[last]) - ((int)left_data_array[left_data_idx]);
-	}
-	if(encoder==RIGHT){
-		if(right_data_idx==0)
-			last = BUFFER_SIZE - 1;
-		else
-			last = right_data_idx - 1;
-		res = ((int)right_data_array[right_data_idx]) - ((int)right_data_array[last]);
-	}
-	
-	sei();
+	/*
+	if (encoder == LEFT)
+		return left_data_array_bottom() - left_data_array_top();
 
-	while(res<MIN_V)//underflow
-		res+=1024;
-	while(res>MAX_V)//overflow
-		res-=1024;
+	if (encoder == RIGHT)
+		return right_data_array_top() - right_data_array_bottom();
 
-	return res;
+	return -1;
+	*/
+	int vel1, vel2, tmp;
+	vel1 = get_dx(encoder, 0);
+	vel2 = get_dx(encoder, 1);
+
+	if (vel1 == ERR_VEL && vel2 == ERR_VEL)
+		return ERR_VEL << 1;
+	else if (vel2 == ERR_VEL)
+		return vel1 << 1;
+	else if (vel1 == ERR_VEL) 
+		return vel2 << 1;
+	else
+		return vel1 + vel2;
 }
+/////////////////////////////////////////////////////////////////////////
 
+/** 
+* @brief Waits until n encoder reads have occurred.
+* Counter is reset on functions exit.
+* 
+* @param n 
+*/
 void encoder_wait(int n){
 	while(data_ready<n);
 	data_ready=0;
@@ -228,39 +242,44 @@
 	encoder_buf_index = (encoder_buf_index + 1) % 5;
 
 	if(encoder_buf_index==0) {
-		  
-		if(left_data_buf & (COF | LIN) || !(left_data_buf & OCF))  left_data = INVALID;
-		else if(((left_data_buf & MagINCn) > 0)  && ((left_data_buf & MagDECn) > 0)) left_data = MAGNET_FAILURE;
+		
+		/*Error handling for the left encoder*/ 
+		if(!(left_data_buf & OCF)) 
+			left_data = ENCODER_DATA_NOT_READY; 
+		if(left_data_buf & (COF | LIN))  
+			left_data = ENCODER_MISALIGNED;
+		else if((left_data_buf & MagINCn) && (left_data_buf & MagDECn)) 
+			left_data = ENCODER_MAGNET_FAILURE;
 		else left_data = (left_data_buf>>5) & 1023;
 			
-		if(right_data_buf & (COF | LIN) || !(right_data_buf & OCF)) right_data = INVALID;
-		else if ( ((right_data_buf & MagINCn) > 0)  && ((right_data_buf & MagDECn) > 0)) right_data = MAGNET_FAILURE;
+		/*Error handling for the right encoder*/ 
+	 	if(!(right_data_buf & OCF))
+			right_data = ENCODER_DATA_NOT_READY;	
+		if(right_data_buf & (COF | LIN)) 
+			right_data = ENCODER_MISALIGNED;
+		else if ((right_data_buf & MagINCn)  && (right_data_buf & MagDECn)) 
+			right_data = ENCODER_MAGNET_FAILURE;
 		else right_data = (right_data_buf>>5) & 1023;
 			
   		left_data_buf = 0;
 		right_data_buf = 0;
 
-		
-		if(left_data != INVALID && left_data != MAGNET_FAILURE) {
+		/*Above 1023 is invalid data*/	
+		if(!(left_data > 1023)) {
 			left_data_array_put(left_data);
 
 			//Adjust left accumulator
-			dx = left_data_array_prev() - left_data;
+			dx = - left_data + left_data_array_prev();
 			
-			//Adjust velocity: save last dx
-			left_v = left_dx;
-
 			if(left_data_array_prev()==0)  dx=0;
 
 			if(dx > 512) left_dx += dx - 1023; //Underflow
 			else if(dx < -512) left_dx += dx + 1023; //Overflow
 			else left_dx += dx;
-			
-			//Adjust velocity: update
-			left_v = left_dx - left_v;
 		}
 
-		if(right_data != INVALID && right_data != MAGNET_FAILURE) {
+		/*Above 1023 is invalid data*/	
+		if(!(right_data > 1023)) {
 			right_data_array_put(right_data);
 
 			//Adjust right accumulator
@@ -279,27 +298,6 @@
 }
 
 
-void encoders_print_data_array(void){
-	int i;
-	usb_puts("Left Data: Pointer is ");
-	usb_puti(left_data_idx);
-	usb_puts("\n\r");
-	for(i=0; i<BUFFER_SIZE; i++){
-		usb_puti(left_data_array[i]);
-		usb_putc(' ');
-	}
-	usb_puts("\r\n");
-	usb_puts("Right Data: Pointer is");
-	usb_puti(right_data_idx);
-	usb_puts("\n\r");
-	for(i=0; i<BUFFER_SIZE; i++){
-		usb_puti(right_data_array[i]);
-		usb_putc(' ');
-	}
-	usb_puts("\r\n\r\n");
-}
-
-
 //Helper Functions
 inline void left_data_array_put(unsigned short int value) {
 	if(left_data_idx == BUFFER_SIZE-1)
Index: branches/encoders/code/lib/src/libdragonfly/spi.c
===================================================================
--- branches/encoders/code/lib/src/libdragonfly/spi.c	(revision 1344)
+++ branches/encoders/code/lib/src/libdragonfly/spi.c	(revision 1345)
@@ -32,7 +32,7 @@
     spi_recv_func = recv_func;
     spi_recv_complete_func = recv_complete_func;
     spi_bytes = 0;
-    usb_puts("\tspi.c Debug: SPI INITIALIZED\n");
+    //usb_puts("\tspi.c Debug: SPI INITIALIZED\n");
 }
 
 /* Transfer a given byte to slave and receive a byte */
